varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

//const float fChromaticValue = 0.005;

uniform int u_chromaticMode;
uniform float u_minDistance; // 0.2
uniform float u_maxDistance; // 0.8
uniform float u_chromaticValue; // 0.005

vec4 ChromaticAberration(sampler2D tex, vec4 clr, vec2 uv)
{
	float dis = distance(uv, vec2(0.5));


	float smoothDis = smoothstep(u_minDistance, u_maxDistance, dis);

	clr.r = texture2D(tex, uv + (smoothDis * u_chromaticValue)).r;
	clr.g = texture2D(tex, uv).g;
	clr.b = texture2D(tex, uv - (smoothDis * u_chromaticValue)).b;

	return clr;
}

void main()
{

	// sample our texture
	//vec4 texColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
	vec4 texColor = texture2D(CC_Texture0, v_texCoord);

	if(0 < u_chromaticMode)
		gl_FragColor = ChromaticAberration(CC_Texture0, texColor, v_texCoord);
	else
		gl_FragColor = texColor;
}