varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform int u_colorGradingMode;
uniform sampler2D u_texColorGrading;

vec3 CalcLUT(sampler2D InLUT, vec3 InColor)
{
	vec2 offset = vec2(0.5 / 256.0, 0.5 / 16.0);
	float Scale = 15.0 / 16.0;

	float IntB = floor(InColor.b * 14.9999) / 16.0;
	float FracB = InColor.b * 15.0 - IntB * 16.0;

	float U = IntB + InColor.r * Scale / 16.0;
	float V = InColor.g * Scale;

	vec3 RG0 = texture2D(InLUT, offset + vec2(U,V)).rgb;
	vec3 RG1 = texture2D(InLUT, offset + vec2(U + 1.0 / 16.0, V)).rgb;

	return mix(RG0, RG1, FracB);
}

void main()
{
	// sample our texture
	//vec4 texColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
	vec4 texColor = texture2D(CC_Texture0, v_texCoord);

	vec3 vecColor = CalcLUT(u_texColorGrading, texColor.rgb);
	
	if(0 < u_colorGradingMode)
		gl_FragColor = vec4(vecColor.rgb, 1.0);
	else
		gl_FragColor = texture2D(CC_Texture0, v_texCoord);
}