varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

const float RADIUS = 0.8;
const float SOFTNESS = 0.45;

uniform float u_radius;
uniform float u_softness;
uniform int u_vignetteMode;


void main()
{
	// sample our texture
	//vec4 texColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
	vec4 texColor = texture2D(CC_Texture0, v_texCoord);

	// determine center
	vec2 position = v_texCoord - vec2(0.5);

	// determine the vector length from center
	float len = length(position);

	//our vignette effect, using smoothstep
	//float vignette = smoothstep(RADIUS, RADIUS - SOFTNESS, len);
	float vignette = smoothstep(u_radius, u_radius - u_softness, len);

	texColor.rgb *= vignette;

	if(0 < u_vignetteMode)
		gl_FragColor = texColor;
	else
		gl_FragColor = texture2D(CC_Texture0, v_texCoord);
		//gl_FragColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);

}